
% Script to learn filter F from GehlerShi dataset and save the first modle
% to the disk. Only need run it once.
%{
%get model from cross validate data set
params = LoadProjectParams('GehlerShi');
data = PrecomputeTrainingData(params.TRAINING.CROSSVALIDATION_DATA_FOLDER, params);
[metrics, models] = CrossValidate(data, params, './cross_validate_model');
model = models{1};
save('cross_validate_model.mat', 'model');
%}

%load testing images
model = load('cross_validate_model.mat');
model = model.model;
params = LoadProjectParams('GehlerShi');
test_images = ImportTestImg();

%array to store error angle
ffcc_err = nan([1 length(test_images)]);
ffcc_uv_distance = nan(size(ffcc_err));
gw_err = nan(size(ffcc_err));
mrgb_err = nan(size(ffcc_err));

for idx = 1:length(test_images)
    test_data = test_images(idx);
    img = test_data.tinted_img;
    rgb_gt = test_data.rgb_gt;
    %dumpf = sprintf('/home/roy/ying/ffcc/data/shi_gehler/preprocessed/test/img_%d.png', idx);
    %imwrite(img, dumpf);
    
    ref_img = VisalizeImg(img, test_data.ccm, 1./rgb_gt);    
    [ffcc_img, ffcc_uv_est] = FFCC(img, test_data.ccm, model, -0.4375, 1/32, 64);
    [gw_img, gw_rgb_est] = GrayWorldAWB(img, test_data.ccm);
    [mrgb_img, mrgb_est] = MaxRgbAWB(img, test_data.ccm);
    
    % calculate the error metric
    
    ffcc_rgb_est = UvToRgb(ffcc_uv_est);
    ffcc_err(idx) = DegreeBetweenTwoVec(ffcc_rgb_est, rgb_gt);
    gw_err(idx) = DegreeBetweenTwoVec(gw_rgb_est, rgb_gt);
    mrgb_err(idx) = DegreeBetweenTwoVec(mrgb_est, rgb_gt);
    fprintf('ffcc=%f, gw=%f, mrgb=%f\n', ffcc_err(idx), gw_err(idx), mrgb_err(idx));
    
    ffcc_uv_distance = (ffcc_uv_est - RgbToUv(rgb_gt)) ./ params.HISTOGRAM.BIN_SIZE;
    ffcc_uv_distance = sum(ffcc_uv_distance.^2, 'all'); 
end












